<template>
    <div class="edit-view">
        <page-title>
            <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
            <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                删除
            </el-button>
            <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
        </page-title>
        <div class="edit-view__content-wrapper">
            <div class="edit-view__content-section">
                <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right"
                         size="small"
                         style="max-width: 500px;">
                        <el-form-item prop="assetId" label="资产ID">
                                    <el-input-number type="number" v-model="formData.assetId"></el-input-number>
                        </el-form-item>
                        <el-form-item prop="contactName" label="收货人">
                                    <el-input v-model="formData.contactName"></el-input>
                        </el-form-item>
                        <el-form-item prop="contactPhone" label="收货电话">
                                    <el-input v-model="formData.contactPhone"></el-input>
                        </el-form-item>
                        <el-form-item prop="address" label="收货地址">
                                    <el-input v-model="formData.address"></el-input>
                        </el-form-item>
                        <el-form-item prop="courier" label="快递">
                                    <el-input v-model="formData.courier"></el-input>
                        </el-form-item>
                        <el-form-item prop="courierId" label="快递单号">
                                    <el-input v-model="formData.courierId"></el-input>
                        </el-form-item>
                    <el-form-item class="form-submit">
                        <el-button @click="onSave" :loading="saving" type="primary">
                            保存
                        </el-button>
                        <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                            删除
                        </el-button>
                        <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
                    </el-form-item>
                </el-form>
            </div>
        </div>
    </div>
</template>
<script>
    export default {
        name: 'AssetPostEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('assetPost/get/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                    contactPhone: [
                        {
                            pattern: /^1[3-9]\d{9}$/,
                            message: "请输入正确的手机号",
                            trigger: "blur"
                        },
                    ],
                },
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/assetPost/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$confirm('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/assetPost/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped></style>
